<?php
// The source code packaged with this file is Free Software, Copyright (C) 2005 by
// Ricardo Galli <gallir at uib dot es>.
// It's licensed under the AFFERO GENERAL PUBLIC LICENSE unless stated otherwise.
// You can get copies of the licenses here:
// 		http://www.affero.org/oagpl.html
// AFFERO GENERAL PUBLIC LICENSE is also included in the file called "COPYING".


@include mnminclude.'ads-credits-functions.php';

include_once(mnminclude.'post.php');

// Warning, it redirects to the content of the variable
if (!empty($globals['lounge'])) {
	header('Location: http://'.get_server_name().$globals['base_url'].$globals['lounge']);
	die;
}

$globals['start_time'] = microtime(true);

header("Content-type: text/html; charset=utf-8");

function do_tabs($tab_name, $tab_selected = false, $extra_tab = false) {
	global $globals;

	$reload_text = _('recargar');
	$active = ' class="tabmain-this"';

	if ($tab_name == "main" ) {
		echo '<ul class="tabmain">' . "\n";

		// url with parameters?
		if (!empty($_SERVER['QUERY_STRING']))
			$query = "?".htmlentities($_SERVER['QUERY_STRING']);

		// START STANDARD TABS
		// First the standard and always present tabs
		// published tab
		if ($tab_selected == 'published') {
			echo '<li '.$active.'><a href="'.$globals['base_url'].'" title="'.$reload_text.'">'._('portada').'</a></li>' . "\n";
		} else {
			echo '<li><a  href="'.$globals['base_url'].'">'._('portada').'</a></li>' . "\n";
		}

		/*
		// Google Map
		if ($tab_selected == 'map') {
			echo '<li '.$active.'><a href="'.$globals['base_url'].'map.php" title="'.$reload_text.'">'._('mapa').'</a></li>' . "\n";
		} else {
			echo '<li><a href="'.$globals['base_url'].'map.php">'._('mapa').'</a></li>' . "\n";
		}
		*/

		// Most voted
		if ($tab_selected == 'popular') {
			echo '<li '.$active.'><a href="'.$globals['base_url'].'topstories.php" title="'.$reload_text.'">'._('populares').'</a></li>' . "\n";
		} else {
			echo '<li><a href="'.$globals['base_url'].'topstories.php">'._('populares').'</a></li>' . "\n";
		}

		// shake it
		if ($tab_selected == 'shakeit') {
			echo '<li '.$active.'><a href="'.$globals['base_url'].'shakeit.php" title="'.$reload_text.'">'._('menear pendientes').'</a></li>' . "\n";
		} else {
			echo '<li><a href="'.$globals['base_url'].'shakeit.php">'._('menear pendientes').'</a></li>' . "\n";
		}
		// END STANDARD TABS

		//Extra tab
		if ($extra_tab) {
			if ($globals['link_permalink']) $url = $globals['link_permalink'];
			else $url = htmlentities($_SERVER['REQUEST_URI']);
			echo '<li '.$active.'><a href="'.$url.'" title="'.$reload_text.'">'.$tab_selected.'</a></li>' . "\n";
		}
		echo '</ul>' . "\n";
	}
}

function do_header($title, $id='home',$num='4',$catname='') {
	global $current_user, $dblang, $globals, $greetings;

	if(!empty($globals['link_id'])) {
		// Pingback autodiscovery
		// http://www.hixie.ch/specs/pingback/pingback
		header('X-Pingback: http://' . get_server_name() . $globals['base_url'] . 'xmlrpc.php');
	}
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' . "\n";
	//echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">' . "\n";
	echo '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="'.$dblang.'" lang="'.$dblang.'">' . "\n";
	echo '<head>' . "\n";
	echo '<!-- TradeDoubler site verification 1307307 -->' . "\n";
	echo '<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />' . "\n";
	echo "<title>$title</title>\n";
	if (!empty($catname)){
	echo '<meta name="description" content="Tutoriales de '.$catname.' y documentos relacionados. En aulaDigital podrás añadir tus propios tutoriales de '. $catname.' y guardar tu lista de tutoriales favoritos"/>'."\n";
	echo '<meta name="keywords" content="tutorial, tutorial '.$catname.', castellano, tutoriales, manual, herramientas, '.$catname.', internet, design, diseño, herramienta, estilo, navegación, ejemplos, informatica, linux, manuales"/>'."\n";
	} elseif (!empty($globals['tags']))  {
	echo '<meta name="description" content="Tutoriales y documentos de tecnología e internet. En aulaDigital podrás añadir tus propios tutoriales y guardar tu lista de tutoriales favoritos"/>'."\n";
	echo '<meta name="keywords" content="'.$globals['tags'].'" />' . "\n";	
	} else {
	echo '<meta name="description" content="Tutoriales y documentos de tecnología e internet. En aulaDigital podrás añadir tus propios tutoriales y guardar tu lista de tutoriales favoritos"/>'."\n";
	echo '<meta name="keywords" content="tutorial, castellano, tutoriales, manual, herramientas, internet, design, diseño, herramienta, estilo, navegación, ejemplos, informatica, linux, manuales"/>'."\n";		
	}
	
	do_css_includes($num);

	echo '<meta name="generator" content="meneame" />' . "\n";
	if (!empty($globals['noindex'])) {
		echo '<meta name="robots" content="noindex,follow"/>' . "\n";
	}

	echo '<link rel="microsummary" type="application/x.microsummary+xml" href="'.$globals['base_url'].'microsummary.xml" />' . "\n";
	echo '<link rel="search" type="application/opensearchdescription+xml" title="'._("menéame search").'" href="http://'.get_server_name().$globals['base_url'].'opensearch_plugin.php"/>'."\n";

	echo '<link rel="alternate" type="application/rss+xml" title="'._('publicadas').'" href="http://'.get_server_name().$globals['base_url'].'rss2.php" />'."\n";
	echo '<link rel="alternate" type="application/rss+xml" title="'._('pendientes').'" href="http://'.get_server_name().$globals['base_url'].'rss2.php?status=queued" />'."\n";
	echo '<link rel="alternate" type="application/rss+xml" title="'._('comentarios').'" href="http://'.get_server_name().$globals['base_url'].'comments_rss2.php" />'."\n";

	if (empty($globals['favicon'])) $globals['favicon'] = 'img/favicons/favicon4.ico';
	echo '<link rel="icon" href="'.$globals['base_url'].$globals['favicon'].'" type="image/x-icon"/>' . "\n";

	if(!empty($globals['link_id'])) {
		// Pingback autodiscovery
		// http://www.hixie.ch/specs/pingback/pingback
		echo '<link rel="pingback" href="http://' . get_server_name() . $globals['base_url'] . 'xmlrpc.php"/>'."\n";
	}

	do_js_includes();

	if (isset($globals['extra_head'])) echo $globals['extra_head'];

	echo '</head>' . "\n";
	
	
	echo '<!-- Global IE fix to avoid layout crash when single word size wider than column width -->
              <!--[if IE]><style type="text/css"> body {word-wrap: break-word;}</style><![endif]-->'. "\n";

	      
		echo "<body>\n";       
	        echo '
  <!-- Main Page Container -->
  <div class="page-container">

   <!-- For alternative headers START PASTE here -->

    <!-- A. HEADER -->      
    <div class="header">
      
      <!-- A.1 HEADER TOP -->
      <div class="header-top">
        
        <!-- Sitelogo and sitename -->
        <a class="sitelogo" href="'.$globals['base_url'].'" title="'._('inicio').'"></a>
        <div class="sitename">

          <h2>Tutoriales y Documentos de Tecnología</h2>
        </div>
	
	
	 <!-- Navigation Level 0 -->
        <!--<div class="nav0">
          <ul>

	 
	  
          </ul>
        </div>-->	
	
	  <!-- Navigation Level 1 -->
        <div class="nav1">
          <ul>
              ';
            
		if($current_user->authenticated) {
    	$randhello = array_rand($greetings, 1);
 		echo '<li><a href="'.get_user_uri($current_user->user_login).'" title="'._('menéame te saluda en ').$greetings[$randhello].'">'.$randhello.'&nbsp;'.$current_user->user_login.'&nbsp;<img src="'.get_avatar_url($current_user->user_id, $current_user->user_avatar, 20).'" width="15" height="15" alt="'.$current_user->user_login.'"/></a> </li> ' . "\n";
  		echo '<li><a href="'.$globals['base_url'].'login.php?op=logout&amp;return='.urlencode($_SERVER['REQUEST_URI']).'">'. _('cerrar sesión').' <img src="'.$globals['base_url'].'img/common/login-bt.png" alt="login button" title="login" width="16" height="16" /></a></li>' . "\n";
	} else {
  		echo '<li><a href="'.$globals['base_url'].'register.php">' . _('registrarse') . '</a> </li> ' . "\n";
  		echo '<li><a href="'.$globals['base_url'].'login.php?return='.urlencode($_SERVER['REQUEST_URI']).'">'. _('login').' <img src="'.$globals['base_url'].'img/common/login-bt.png" alt="login button" title="login" width="16" height="16" border="0"/> </a></li>' . "\n";
	}

	
	echo '
	    
          </ul>
        </div>              
      </div>
      
      <!-- A.2 HEADER MIDDLE -->
      <div class="header-middle">    
   
        <!-- Site message -->
        <div class="sitemessage">

          <h1>Tutoriales y Documentos de tecnología</h1>
          <h2>Ahora con preguntas y respuestas.<br /></h2>
          <h3>&rsaquo;&rsaquo;&nbsp;<a href="/respuestas">Ver nueva sección</a></h3>
	      </div>     </div>
	      <p align="center">
	      
	      <!--/* OpenX Javascript Tag v2.8.2 */-->




<script type=\'text/javascript\'><!--//<![CDATA[
   var m3_u = (location.protocol==\'https:\'?\'https://ads.acilia.es/www/delivery/ajs.php\':\'http://ads.acilia.es/www/delivery/ajs.php\');
   var m3_r = Math.floor(Math.random()*99999999999);
   if (!document.MAX_used) document.MAX_used = ',';
   document.write ("<scr"+"ipt type=\'text/javascript\' src=\'"+m3_u);
   document.write ("?zoneid=1");
   document.write (\'&amp;cb=\' + m3_r);
   if (document.MAX_used != \',\') document.write ("&amp;exclude=" + document.MAX_used);
   document.write (document.charset ? \'&amp;charset=\'+document.charset : (document.characterSet ? \'&amp;charset=\'+document.characterSet : \'\'));
   document.write ("&amp;loc=" + escape(window.location));
   if (document.referrer) document.write ("&amp;referer=" + escape(document.referrer));
   if (document.context) document.write ("&context=" + escape(document.context));
   if (document.mmm_fo) document.write ("&amp;mmm_fo=1");
   document.write ("\'><\/scr"+"ipt>");
//]]>--></script>

</p>
      <!-- A.3 HEADER BOTTOM -->
      <div class="header-bottom">
      
        <!-- Navigation Level 2 (Drop-down menus) -->
        <div class="nav2">
	
          <!-- Navigation item -->
	  
	 <ul><li class="first"><a href="/">tutoriales publicados</a></li></ul> 
	<ul><li class="second"><a href="'.$globals['base_url'].'shakeit.php">tutoriales en revisión</a></li></ul>
	<ul><li class="second"><a href="'.$globals['base_url'].'submit.php">añadir tutorial</a></li></ul>';
	
	if($current_user->authenticated) {
	echo '<ul><li class="second"><a href="'.get_user_uri($current_user->user_login).'/favorites" title="Favoritos">Favoritos</a></li></ul>';
	} else {
	echo '<ul><li class="second"><a href="'.$globals['base_url'].'login.php">Login</a></li></ul>';
	}
         
	echo '
        </div>
	  </div>

      <!-- A.4 HEADER BREADCRUMBS -->

      <!-- Breadcrumbs -->
     <div class="header-breadcrumbs">
     <!--   <ul>
          <li><a href="#">Home</a></li>

          <li><a href="#">Webdesign</a></li>
          <li><a href="#">Templates</a></li>
          <li>Multiflex-3</li>
        </ul>-->

        <!-- Search form -->                  

	 <!-- Search form -->                  
       <!--     <div class="searchform">

	
     <form action="'.$globals['base_url'].'search.php" method="get" class="form">

            <fieldset>
              <input value="'._('buscar...').'" name="q" class="field" onblur="if(this.value==\'\') this.value=\''._('buscar...').'\';" onfocus="if(this.value==\''._('buscar...').'\') this.value=\'\';"/>
            <input type="submit" value="IR" name="button" class="button" /> 
            </fieldset>
          </form>
        </div>-->
	
	
      </div>
    </div>

    <!-- For alternative headers END PASTE here -->

	 <!-- B. MAIN -->
    <div class="main">
 
      <!-- B.1 MAIN NAVIGATION -->
      <div class="main-navigation">

        <!-- Navigation Level 3 -->
        <div class="round-border-topright"></div>
        <h1 class="first">Categorías</h1>

        <!-- Navigation with grid style -->';


$catid= isset($_REQUEST['category']) ?  $_REQUEST['category'] : '';

do_mnu_categories_horizontal($catid);

echo '
       <!-- Template infos -->                
	';

	

	echo '
      <!--  <h1>Mapas</h1>'."\n";
	

	echo '<ul id="mapslist">'."\n";
	echo '<li><a href="'.$globals['base_url'].'geovision.php">'._('geovisión').'</a></li>'."\n";
	echo '<li><a href="'.$globals['base_url'].'map.php">'._('noticias').'</a></li>'."\n";
	echo '</ul>'."\n-->";
	
	echo '
	
	
	
      </div>
 
      <!-- B.2 MAIN CONTENT -->
      
      ';
      
}
      

function do_header_comos($title, $id='home',$num='4',$catname='') {
	global $current_user, $dblang, $globals, $greetings;

	if(!empty($globals['link_id'])) {
		// Pingback autodiscovery
		// http://www.hixie.ch/specs/pingback/pingback
		header('X-Pingback: http://' . get_server_name() . $globals['base_url'] . 'xmlrpc.php');
	}
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' . "\n";
	//echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">' . "\n";
	echo '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="'.$dblang.'" lang="'.$dblang.'">' . "\n";
	echo '<head>' . "\n";
	echo '<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />' . "\n";
	echo "<title>$title</title>\n";
	if (!empty($catname)){
	echo '<meta name="description" content="Tutoriales de '.$catname.' y documentos relacionados. En aulaDigital podrás añadir tus propios tutoriales de '. $catname.' y guardar tu lista de tutoriales favoritos"/>'."\n";
	echo '<meta name="keywords" content="tutorial, tutorial '.$catname.', castellano, tutoriales, manual, herramientas, '.$catname.', internet, design, diseño, herramienta, estilo, navegación, ejemplos, informatica, linux, manuales"/>'."\n";
	} elseif (!empty($globals['tags']))  {
	echo '<meta name="description" content="Tutoriales y documentos de tecnología e internet. En aulaDigital podrás añadir tus propios tutoriales y guardar tu lista de tutoriales favoritos"/>'."\n";
	echo '<meta name="keywords" content="'.$globals['tags'].'" />' . "\n";	
	} else {
	echo '<meta name="description" content="Tutoriales y documentos de tecnología e internet. En aulaDigital podrás añadir tus propios tutoriales y guardar tu lista de tutoriales favoritos"/>'."\n";
	echo '<meta name="keywords" content="tutorial, castellano, tutoriales, manual, herramientas, internet, design, diseño, herramienta, estilo, navegación, ejemplos, informatica, linux, manuales"/>'."\n";		
	}
	
	do_css_includes($num);

	echo '<meta name="generator" content="meneame" />' . "\n";
	if (!empty($globals['noindex'])) {
		echo '<meta name="robots" content="noindex,follow"/>' . "\n";
	}

	echo '<link rel="microsummary" type="application/x.microsummary+xml" href="'.$globals['base_url'].'microsummary.xml" />' . "\n";
	echo '<link rel="search" type="application/opensearchdescription+xml" title="'._("menéame search").'" href="http://'.get_server_name().$globals['base_url'].'opensearch_plugin.php"/>'."\n";

	echo '<link rel="alternate" type="application/rss+xml" title="'._('publicadas').'" href="http://'.get_server_name().$globals['base_url'].'rss2.php" />'."\n";
	echo '<link rel="alternate" type="application/rss+xml" title="'._('pendientes').'" href="http://'.get_server_name().$globals['base_url'].'rss2.php?status=queued" />'."\n";
	echo '<link rel="alternate" type="application/rss+xml" title="'._('comentarios').'" href="http://'.get_server_name().$globals['base_url'].'comments_rss2.php" />'."\n";

	if (empty($globals['favicon'])) $globals['favicon'] = 'img/favicons/favicon4.ico';
	echo '<link rel="icon" href="'.$globals['base_url'].$globals['favicon'].'" type="image/x-icon"/>' . "\n";

	if(!empty($globals['link_id'])) {
		// Pingback autodiscovery
		// http://www.hixie.ch/specs/pingback/pingback
		echo '<link rel="pingback" href="http://' . get_server_name() . $globals['base_url'] . 'xmlrpc.php"/>'."\n";
	}

	do_js_includes();

	if ($globals['extra_head']) echo $globals['extra_head'];

	echo '</head>' . "\n";
	
	
	echo '<!-- Global IE fix to avoid layout crash when single word size wider than column width -->
              <!--[if IE]><style type="text/css"> body {word-wrap: break-word;}</style><![endif]-->'. "\n";

	      
		echo "<body>\n";       
	        echo '
  <!-- Main Page Container -->
  <div class="page-container">

   <!-- For alternative headers START PASTE here -->

    <!-- A. HEADER -->      
    <div class="header">
      
      <!-- A.1 HEADER TOP -->
      <div class="header-top">
        
        <!-- Sitelogo and sitename -->
        <a class="sitelogo" href="'.$globals['base_url'].'" title="'._('inicio').'"></a>
        <div class="sitename">

          <h2>Tutoriales y Documentos de Tecnología</h2>
        </div>
	
	
	 <!-- Navigation Level 0 -->
        <!--<div class="nav0">
          <ul>

	 
	  
          </ul>
        </div>-->	
	
	  <!-- Navigation Level 1 -->
        <div class="nav1">
          <ul>
              ';
            
		if($current_user->authenticated) {
    	$randhello = array_rand($greetings, 1);
 		echo '<li><a href="'.get_user_uri($current_user->user_login).'" title="'._('menéame te saluda en ').$greetings[$randhello].'">'.$randhello.'&nbsp;'.$current_user->user_login.'&nbsp;<img src="'.get_avatar_url($current_user->user_id, $current_user->user_avatar, 20).'" width="15" height="15" alt="'.$current_user->user_login.'"/></a> </li> ' . "\n";
  		echo '<li><a href="'.$globals['base_url'].'login.php?op=logout&amp;return='.urlencode($_SERVER['REQUEST_URI']).'">'. _('cerrar sesión').' <img src="'.$globals['base_url'].'img/common/login-bt.png" alt="login button" title="login" width="16" height="16" /></a></li>' . "\n";
	} else {
  		echo '<li><a href="'.$globals['base_url'].'register.php">' . _('registrarse') . '</a> </li> ' . "\n";
  		echo '<li><a href="'.$globals['base_url'].'login.php?return='.urlencode($_SERVER['REQUEST_URI']).'">'. _('login').' <img src="'.$globals['base_url'].'img/common/login-bt.png" alt="login button" title="login" width="16" height="16" border="0"/> </a></li>' . "\n";
	}

	
	echo '
	    
          </ul>
        </div>              
      </div>
      
      <!-- A.2 HEADER MIDDLE -->
      <div class="header-middle">    
   
        <!-- Site message -->
        <div class="sitemessage">

          <h1>APRENDE &bull; DESCUBRE &bull; COMPARTE</h1>
          <h2>La segunda generación de AulaDigital ha llegado.<br /></h2>
          <h3>&rsaquo;&rsaquo;&nbsp;<a href="http://www.quevidaesta.com/index.php/aula-digital-vive/2008/11/27/">Más detalles</a></h3>

        </div>        
      </div>
      
      <!-- A.3 HEADER BOTTOM -->
      <div class="header-bottom">
      
        <!-- Navigation Level 2 (Drop-down menus) -->
        <div class="nav2">
	
          <!-- Navigation item -->
	  
	 <ul><li class="first"><a href="/">tutoriales publicados</a></li></ul> 
	<ul><li class="second"><a href="'.$globals['base_url'].'shakeit.php">tutoriales en revisión</a></li></ul>
	<ul><li class="second"><a href="'.$globals['base_url'].'submit.php">añadir tutorial</a></li></ul>';
	
	if($current_user->authenticated) {
	echo '<ul><li class="second"><a href="'.get_user_uri($current_user->user_login).'/favorites" title="Favoritos">Favoritos</a></li></ul>';
	} else {
	echo '<ul><li class="second"><a href="'.$globals['base_url'].'login.php">Login</a></li></ul>';
	}
         
	echo '
        </div>
	  </div>

      <!-- A.4 HEADER BREADCRUMBS -->

      <!-- Breadcrumbs -->
     <div class="header-breadcrumbs">
     <!--   <ul>
          <li><a href="#">Home</a></li>

          <li><a href="#">Webdesign</a></li>
          <li><a href="#">Templates</a></li>
          <li>Multiflex-3</li>
        </ul>-->

        <!-- Search form -->                  

	 <!-- Search form -->                  
       <!--     <div class="searchform">

	
     <form action="'.$globals['base_url'].'search.php" method="get" class="form">

            <fieldset>
              <input value="'._('buscar...').'" name="q" class="field" onblur="if(this.value==\'\') this.value=\''._('buscar...').'\';" onfocus="if(this.value==\''._('buscar...').'\') this.value=\'\';"/>
            <input type="submit" value="IR" name="button" class="button" /> 
            </fieldset>
          </form>
        </div>-->
	
	
      </div>
    </div>

    <!-- For alternative headers END PASTE here -->

	 <!-- B. MAIN -->
    <div class="main">
 
    
 
      <!-- B.2 MAIN CONTENT -->
      
      ';
      
}











function do_sidebar() {
      
      echo '
      <!-- B.3 SUBCONTENT -->
      <div class="main-subcontent">
      <p>
      <a href="http://clk.tradedoubler.com/click?p(4326)a(1307307)g(16428648)" title="Patrocinado por Dell" target="_blank">Patrocinado por Dell</a><img src="http://impes.tradedoubler.com/imp?type(inv)g(16428648)a(1307307)" alt="" />
      </p>
      <!-- Subcontent unit -->
        <div class="subcontent-unit-border-blue">
          <div class="round-border-topleft"></div><div class="round-border-topright"></div>
          <h1 class="blue">Cómo Funciona</h1>

          <ul><li>Cualquier usuario puede <a href="/submit.php" title="añadir tutorial"> añadir un tutorial.</a> Mediante esta acción, propone la inclusión de un tutorial en el directorio.</li></ul>
          <ul><li>El tutorial pasa a la cola de <a href="/shakeit.php" title="tutoriales en revisión">tutoriales en revisión</a>, donde todos los usuarios votan los más interesantes, que serán incluidos en el directorio, pasando por la portada.</li></ul>
          <ul><li>Además de esto, puedes comentarlos, guardarlos en favoritos, anotarlos... en definitiva, tener tu espacio con los tutoriales y documentos que más te interesan.</li></ul>
          <ul><li>Más información en las <a href="/faq-es.php">FAQs</a>.</li></ul>
        </div>

       <!-- Subcontent unit -->
        <div class="subcontent-unit-border-green">
          <div class="round-border-topleft"></div><div class="round-border-topright"></div>
          <h1 class="green">Suscripciones RSS</h1>';
	  do_rss();
       echo '
        </div>
	
        <!-- Subcontent unit -->
        <!--<div class="subcontent-unit-border">

          <div class="round-border-topleft"></div><div class="round-border-topright"></div>
          <h1>Populares</h1>';
	  
	  do_best_stories();
	  
	  echo '
        </div>-->

      <!-- Subcontent unit -->
        <div class="subcontent-unit-border">
		<div class="round-border-topleft"></div><div class="round-border-topright"></div>
		<h1 class="grey">Comos de Linux</h1>
		<ul>
		  <li><a href="/howtos-linux">Howtos Linux</a></li>
		</ul>
	</div>
	        <!-- Subcontent unit -->
      <!--  <div class="subcontent-unit-border">
          <div class="round-border-topleft"></div><div class="round-border-topright"></div>';
	echo '<h1 class="grey">Estadísticas</h1>'."\n";
     	echo '<ul id="statisticslist">'."\n";
	echo '<li><a href="'.$globals['base_url'].'topusers.php">'._('usuarios').'</a></li>'."\n";
	echo '<li><a href="'.$globals['base_url'].'topstories.php">'._('populares').'</a></li>'."\n";
	echo '<li><a href="'.$globals['base_url'].'promote.php">'._('candidatas').'</a></li>'."\n";
	echo '<li><a href="'.$globals['base_url'].'topcommented.php">'._('más comentadas').'</a></li>'."\n";
	echo '<li><a href="'.$globals['base_url'].'topcomments.php">'._('mejores comentarios').'</a></li>'."\n";
	echo '<li><a href="'.$globals['base_url'].'cloud.php">'._('nube de etiquetas').'</a></li>'."\n";
	echo '<li><a href="'.$globals['base_url'].'sitescloud.php">'._('nube de webs').'</a></li>'."\n";
	echo '</ul>'."\n";
	echo '
        </div>-->
	

      </div>

      

    ';
    
    }
    
    
function do_last() {
 

    echo '    
    
     </div>
       <!-- C. FOOTER AREA -->
    
             <div class="footer">';
    
    
//    do_footer();
    
    echo '
      <p>Copypaste (c) 1999-'.date("Y").' AulaDigital.com</p>
      <p class="credits">Basado en diseño de <a href="http://www.1-2-3-4.info/" title="Diseño del Sitio">Wolfgang</a> y software de <a href="http://meneame.net" title="Meneame">Meneame.net</a> (<a href="/COPYING" title="licencia">licencia</a>,<a href="http://creativecommons.org/licenses/by-sa/2.5/">licencia gráficos</a>,<a href="http://falklands.globat.com/~auladigital.com/code_adigital.zip">código</a>)  | Adaptado por <a href="http://www.quevidaesta.com" title="Marcos Labad">Marcos Labad</a>, <a href="http://www.acilia.es">Acilia Internet</a> </p><br/><br/>
<p>

Intentamos seguir los estándards, no como IE <br/><br/>
    <a href="http://validator.w3.org/check?uri=referer"><img
        src="http://www.w3.org/Icons/valid-xhtml10"
        alt="Valid XHTML 1.0! (Si no, avisa que se rompió algo!)" title="Valid XHTML 1.0! (Si no, avisa que se rompió algo)" height="31" width="88" border="0"/></a>

	 <a href="http://jigsaw.w3.org/css-validator/">
        <img style="border:0;width:88px;height:31px"
            src="http://jigsaw.w3.org/css-validator/images/vcss"
            alt="Valid CSS! (Si no, avisa que se rompió algo!)" title="Valid CSS! (Si no, avisa que se rompió algo)" />
    </a>
	
	</p>

    </div>      

    
    </div> 
        <script type="text/javascript">
var gaJsHost = (("https:" == document.location.protocol) ? "https://ssl." : "http://www.");
document.write(unescape("%3Cscript src=\'" + gaJsHost + "google-analytics.com/ga.js\' type=\'text/javascript\'%3E%3C/script%3E"));
</script>
<script type="text/javascript">
try {
var pageTracker = _gat._getTracker("UA-2208538-3");
pageTracker._trackPageview();
} catch(err) {}</script>
      
</body>
</html>
	
	
	
	
	
	
	';
	      
	      
	      
	      
/*
	echo '<div id="wrap">' . "\n";

	echo '<div id="header">' . "\n";
	echo '<a href="'.$globals['base_url'].'" title="'._('inicio').'" id="logo">'._("menéame").'</a>'."\n";
	echo '<ul id="headtools">' . "\n";

	echo '<li><a href="http://meneame.wikispaces.com/Comenzando"><img src="'.$globals['base_url'].'img/common/help-bt.png" alt="help button" title="'._('ayuda').'" width="16" height="16" /></a></li>';
	if ($current_user->user_level=='god' || $current_user->user_level=='admin') {
		echo '<li><a href="'.$globals['base_url'].'admin/bans.php"><img src="'.$globals['base_url'].'img/common/tools-bt.png" alt="tools button" title="herramientas" width="19" height="16" /> </a></li>' . "\n";
	}

	if($current_user->authenticated) {
    	$randhello = array_rand($greetings, 1);
 		echo '<li><a href="'.get_user_uri($current_user->user_login).'" title="'._('menéame te saluda en ').$greetings[$randhello].'">'.$randhello.'&nbsp;'.$current_user->user_login.'&nbsp;<img src="'.get_avatar_url($current_user->user_id, $current_user->user_avatar, 20).'" width="15" height="15" alt="'.$current_user->user_login.'"/></a></li>' . "\n";
  		echo '<li class="noborder"><a href="'.$globals['base_url'].'login.php?op=logout&amp;return='.urlencode($_SERVER['REQUEST_URI']).'">'. _('cerrar sesión').' <img src="'.$globals['base_url'].'img/common/login-bt.png" alt="login button" title="login" width="16" height="16" /></a></li>' . "\n";
	} else {
  		echo '<li><a href="'.$globals['base_url'].'register.php">' . _('registrarse') . '</a></li>' . "\n";
  		echo '<li class="noborder"><a href="'.$globals['base_url'].'login.php?return='.urlencode($_SERVER['REQUEST_URI']).'">'. _('login').' <img src="'.$globals['base_url'].'img/common/login-bt.png" alt="login button" title="login" width="16" height="16" /> </a></li>' . "\n";
	}

	//echo '<li><a href="'.$globals['base_url'].'faq-'.$dblang.'.php">' . _('acerca de menéame').'</a></li>' . "\n";

	

	echo '</ul>' . "\n";
	echo '<span class="header-left">&nbsp;</span>' . "\n";
	echo '</div>' . "\n";
	echo '<a id="eli" href="'.$globals['base_url'].'" title="'._('inicio').'">'._("Eli").'</a>'."\n";
	echo '<div id="naviwrap">'."\n";
	echo '<ul id="navigation">'."\n";
	echo '<li class="first"><a href="'.$globals['base_url'].'submit.php">enviar noticia</a></li>'."\n";
	echo '<li class="second"><a href="'.$globals['base_url'].'shakeit.php">pendientes</a></li>'."\n";
	echo '<li class="third"><a href="'.$globals['base_url'].'sneak.php">fisgona</a></li>'."\n";
	echo '<li class="fourth"><a href="'.$globals['base_url'].'notame/">nótame</a></li>'."\n";
	echo '</ul></div>'."\n";
	do_banner_top();
	echo '<div id="container">'."\n";
*/
	}

function do_css_includes($num = '4') {
	global $globals;
/*
	if ($globals['css_main']) {
		echo '<link rel="stylesheet" type="text/css" media="screen" href="'.$globals['base_url'].$globals['css_main'].'" />' . "\n";
	}
	if ($globals['css_color']) {
		echo '<link rel="stylesheet" type="text/css" media="screen" href="'.$globals['base_url'].$globals['css_color'].'" />' . "\n";
	}*/
	foreach ($globals['extra_css'] as $css) {
		echo '<link rel="stylesheet" type="text/css" media="screen" href="'.$globals['base_url'].'css/'.$css.'" />' . "\n";
	}
	/*
	// IE6 hacks
	echo '<!--[if lte IE 6]>'."\n";
	//echo '<style type="text/css" media="all">@import "'.$globals['base_url'].'css/ie6-hacks.css";</style>'."\n";
	echo '<link rel="stylesheet" type="text/css" media="screen" href="'.$globals['base_url'].'css/ie6-hacks.css" />'."\n";
	echo '<![endif]-->'."\n";
	
*/


   /*       echo '<link rel="stylesheet" type="text/css" media="screen" href="'.$globals['base_url'].$globals['css_main'].'" />' . "\n";
	
	  echo '<link rel="stylesheet" type="text/css" media="screen,projection,print" href="./css/layout4_setup.css" /> */

           echo '<link rel="stylesheet" type="text/css" media="screen,projection,print" href="'.$globals['base_url'].'css/es/layout'.$num.'_text.css" />' . "\n";
           echo '<link rel="stylesheet" type="text/css" media="screen,projection,print" href="'.$globals['base_url'].'css/es/layout'.$num.'_setup.css" />' . "\n";

}

function do_js_includes() {
	global $globals;

	echo '<script type="text/javascript">var base_url="'.$globals['base_url'].'";</script>'."\n";
	echo '<script src="'.$globals['base_url'].'js/jquery.pack.js" type="text/javascript"></script>' . "\n";
	// See http://code.google.com/apis/ajaxlibs/documentation/#jquery
	//echo '<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.2.6/jquery.min.js"></script>' . "\n";
	// Cache for Ajax
	echo '<script src="'.$globals['base_url'].'js/jsoc-0.12.0.js" type="text/javascript"></script>' . "\n";
	echo '<script src="'.$globals['base_url'].'js/jquery.simplemodal.pack.js" type="text/javascript"></script>' . "\n";
	echo '<script src="'.$globals['base_url'].'js/general03.js" type="text/javascript"></script>' . "\n";
	do_js_from_array($globals['extra_js']);
	echo '<script type="text/javascript">if(top.location != self.location)top.location = self.location;'."\n";
	if ($globals['extra_js_text']) {
		 echo $globals['extra_js_text']."\n";
	}
	echo '</script>'."\n";
}

function do_js_from_array($array) {
	global $globals;

	foreach ($array as $js) {
		if (preg_match('/^http|^\//', $js)) {
			echo '<script src="'.$js.'" type="text/javascript"></script>' . "\n";
		} else {
			echo '<script src="'.$globals['base_url'].'js/'.$js.'" type="text/javascript"></script>' . "\n";
		}
	}
}

function do_footer($credits = true) {
	global $globals;

//	echo "</div><!--#container closed-->\n";
	if($credits) @do_credits();
	do_js_from_array($globals['post_js']);

	// warn warn warn 
	// dont do stats of password recovering pages
	@include('ads/stats.inc');
	printf("\n<!--Generated in %4.3f seconds-->\n", microtime(true) - $globals['start_time']);
//	echo "</div></body></html>\n";
}

function do_footer_menu() {
	global $globals, $current_user;

	echo '<div id="footwrap">'."\n";

	echo '<div id="footcol1">'."\n";
	do_rss();
	echo '</div>'."\n";

	echo '<div id="footcol2">'."\n";
	do_footer_help();
	echo '</div>'."\n";

	echo '<div id="footcol3">'."\n";
	do_footer_plus_meneame();
	echo '</div>'."\n";

	echo '<div id="footcol4">'."\n";
	echo '<h5>estadísticas</h5>'."\n";
	echo '<ul id="statisticslist">'."\n";
	echo '<li><a href="'.$globals['base_url'].'topusers.php">'._('usuarios').'</a></li>'."\n";
	echo '<li><a href="'.$globals['base_url'].'topstories.php">'._('populares').'</a></li>'."\n";
	echo '<li><a href="'.$globals['base_url'].'promote.php">'._('candidatas').'</a></li>'."\n";
	echo '<li><a href="'.$globals['base_url'].'topcommented.php">'._('más comentadas').'</a></li>'."\n";
	echo '<li><a href="'.$globals['base_url'].'topcomments.php">'._('mejores comentarios').'</a></li>'."\n";
	echo '<li><a href="'.$globals['base_url'].'cloud.php">'._('nube de etiquetas').'</a></li>'."\n";
	echo '<li><a href="'.$globals['base_url'].'sitescloud.php">'._('nube de webs').'</a></li>'."\n";
	echo '</ul>'."\n";
	echo '</div>'."\n";

	echo '<div id="footcol5">'."\n";


	do_footer_shop();

	echo '</div>'."\n";

	echo '</div>'."\n";
}

function do_rss() {
	global $globals, $current_user;

	if(!empty($globals['link_id'])) $is_history = true;

	if(isset($is_history)) $hlevel='h4'; else $hlevel='h5';

	//echo '<'.$hlevel.'>'._('suscripciones por RSS').'</'.$hlevel.'>'."\n";

	if(isset($is_history)) {
            $ulclass=' class="storyrsslist"';
        } else {

            $ulclass = '';

        }
	echo '<ul'.$ulclass.'>'."\n";

	if(!empty($_REQUEST['q'])) {
		$search =  htmlspecialchars($_REQUEST['q']);
		echo '<li>';
		echo '<a href="'.$globals['base_url'].'rss2.php?q='.urlencode($search).'" rel="rss">'._("búsqueda").': '. htmlspecialchars($_REQUEST['q'])."</a>\n";
		echo '</li>';
	}

	// RSS related to a single link
	if (isset($globals['link'])) {
		if(!empty($globals['link']->meta_name)) {
			echo '<li>';
			echo '<a href="'.$globals['base_url'].'rss2.php?meta='.$globals['link']->meta_id.'&amp;status=all" rel="rss">'._('temática').': <em>'.$globals['link']->meta_name."</em></a>\n";
			echo '</li>';
		}
		if(!empty($globals['link']->category_name)) {
			echo '<li>';
			echo '<a href="'.$globals['base_url'].'rss2.php?category='.$globals['link']->category.'&amp;status=all" rel="rss">'._('categoría').': <em>'.$globals['link']->category_name."</em></a>\n";
			echo '</li>';
		}
	}
	echo '<li>';
	echo '<a href="'.$globals['base_url'].'rss2.php" rel="rss">'._('publicados').'</a>';
	echo '</li>' . "\n";
	
	echo '<li>';
	echo '<a href="'.$globals['base_url'].'rss2.php?status=queued" rel="rss">'._('en revisión').'</a>';
	echo '</li>' . "\n";

	if(isset($is_history)) {
		echo '<li>';
		echo '<a href="'.$globals['base_url'].'comments_rss2.php?id='.$globals['link_id'].'" rel="rss">'._('comentarios <em>de estos tutoriales</em>').'</a>';
		echo '</li>' . "\n";
	}

	if($current_user->user_id > 0) {
		echo '<li>';
		echo '<a href="'.$globals['base_url'].'comments_rss2.php?conversation_id='.$current_user->user_id.'" rel="rss" title="'._('comentarios de los tutoriales donde has comentado').'">'._('mis conversaciones').'</a>';
		echo '</li>' . "\n";
		echo '<li>';
		echo '<a href="'.$globals['base_url'].'comments_rss2.php?author_id='.$current_user->user_id.'" rel="rss">'._('comentarios a mis tutoriales').'</a>';
		echo '</li>' . "\n";
	}

	echo '<li>';
	echo '<a href="'.$globals['base_url'].'comments_rss2.php" rel="rss">'._('todos los comentarios').'</a>';
	echo '</li>' . "\n";

	/*
	if(empty($globals['link_id'])) { // Netvibes. In homepage only.
		echo '<li class="mnu-rss-external">';
		echo '<a href="http://www.netvibes.com/subscribe.php?preconfig=7cec38e5bac4adc3608f68e8603bb3c3" title="Añadir a Netvibes"><img src="http://www.netvibes.com/img/add2netvibes.gif" width="91" height="17" border="0" alt="Añadir a Netvibes"/></a>';
		echo '</li>';
	}
	*/

	echo '</ul>' . "\n";
}

function get_toggler_plusminus($container_id, $enabled = false) {
	global $globals;

	static $n = 0;

	if ($enabled) {
		$image = $globals['base_url'].'img/common/minus-01.png';
	} else {
		$image = $globals['base_url'].'img/common/plus-01.png';
	}
	echo "<script type=\"text/javascript\">";
	if ($n == 0) {
		echo "var plus = base_url + 'img/common/plus-01.png';\n";
		echo "var minus = base_url + 'img/common/minus-01.png';\n";
	}
	echo "bindTogglePlusMinus('toggle_i_$n', 'toggle_l_$n', '$container_id')";
	echo "</script>\n";
	return "<a class='toggler' id='toggle_l_$n' href=''><img src='$image' id='toggle_i_$n' alt='' width='12' height='12'/></a>";
	$n++;
}

function do_mnu_categories_horizontal($what_cat_id) {
	global $db, $dblang, $globals;

/*	echo '<div id="topcatlist" class="catsub-block"';
	if (! $what_cat_id) echo ' style="display:none;"';
	echo "><ul>\n"; */
       


	$query=preg_replace('/category=[0-9]*/', '', $_SERVER['QUERY_STRING']);
	// If a meta is not a "virtual" one, delete it.
	$query=preg_replace('/meta=[a-z]+/i', '', $query);
	// Always return to page 1
	$query=preg_replace('/page=[0-9]*/', '', $query);
	$query=preg_replace('/name=[a-z\s\/\+\.áéíóúüçñ\-]*/i', '', $query);
	$query=preg_replace('/^&*(.*)&*$/', "$1", $query);
	if(!empty($query)) {
		$query = htmlspecialchars($query);
		$query = "?$query";
	}

	// draw categories
	
	echo '<dl class="nav3-grid">';
	if (!empty($globals['meta_categories'])) {
		$category_condition = "category_id in (".$globals['meta_categories'].")";
	} else {
		$category_condition = "category_parent > 0";
	}
	$categories = $db->get_results("SELECT category_id, category_name FROM categories WHERE $category_condition ORDER BY category_name ASC");
	if ($categories) {
		$i = 0;
		foreach ($categories as $category) {
			if($category->category_id == $what_cat_id) {
				$globals['category_id'] = $category->category_id;
				$globals['category_name'] = $category->category_name;
				$thiscat = ' class="thiscat"';
			} else {
				$thiscat = '';
			}

			echo '<dt'.$thiscat.'>';
			if ($i > 0) {
				echo '&nbsp;'; 
			}
			$i++;
//			echo '<a href="/'.$category->category_name.'-ca'.$category->category_id.$query.'">';
			echo '<a href="/'.$category->category_name.'-ca'.$category->category_id.'">';

			echo _($category->category_name);
			echo "</a></dt>\n";
		}
	}


	echo '</dl>' . "\n";

}

function force_authentication() {
	global $current_user;

	if(!$current_user->authenticated) {
		header('Location: '.$globals['base_url'].'login.php?return='.$_SERVER['REQUEST_URI']);
		die;
	}
	return true;
}

function do_pages($total, $page_size=25, $margin = true) {
	global $db;

	if ($total < $page_size) return;

	$index_limit = 5;

	$query=preg_replace('/page=[0-9]+/', '', $_SERVER['QUERY_STRING']);
	$query=preg_replace('/^&*(.*)&*$/', "$1", $query);
	if(!empty($query)) {
		$query = htmlspecialchars($query);
		$query = "&amp;$query";
	}
	
	$current = get_current_page();
	$total_pages=ceil($total/$page_size);
	$start=max($current-intval($index_limit/2), 1);
	$end=$start+$index_limit-1;
	
	if ($margin) {
		echo '<div class="pages-margin">';
	} else {
		echo '<div class="pages">';
	}

	if($current==1) {
		echo '<span class="nextprev">&#171; '._('anterior'). '</span>';
	} else {
		$i = $current-1;
		echo '<a href="?page='.$i.$query.'">&#171; '._('anterior').'</a>';
	}

	if($start>1) {
		$i = 1;
		echo '<a href="?page='.$i.$query.'" title="'._('ir a página')." $i".'">'.$i.'</a>';
		echo '<span>...</span>';
	}
	for ($i=$start;$i<=$end && $i<= $total_pages;$i++) {
		if($i==$current) {
			echo '<span class="current">'.$i.'</span>';
		} else {
			echo '<a href="?page='.$i.$query.'" title="'._('ir a página')." $i".'">'.$i.'</a>';
		}
	}
	if($total_pages>$end) {
		$i = $total_pages;
		echo '<span>...</span>';
		echo '<a href="?page='.$i.$query.'" title="'._('ir a página')." $i".'">'.$i.'</a>';
	}
	if($current<$total_pages) {
		$i = $current+1;
		echo '<a href="?page='.$i.$query.'">&#187; '._('siguiente').'</a>';
	} else {
		echo '<span class="nextprev">&#187; '._('siguiente'). '</span>';
	}
	echo "</div><!--html1:do_pages-->\n";

}

//Used in editlink.php and submit.php
function print_categories_form($selected = 0) {
	global $db, $dblang;
	echo '<fieldset style="clear: both;">';
	echo '<legend>'._('selecciona la categoría más apropiada').'</legend>'."\n";
	$metas = $db->get_results("SELECT category_id, category_name FROM categories WHERE category_parent = 0 ORDER BY category_name ASC");
	foreach ($metas as $meta) {
		echo '<dl class="categorylist"><dt>'.$meta->category_name.'</dt>'."\n";
		$categories = $db->get_results("SELECT category_id, category_name FROM categories WHERE category_parent = $meta->category_id ORDER BY category_name ASC");
		foreach ($categories as $category) {
			echo '<dd><input name="category" type="radio" ';
			if ($selected == $category->category_id) echo '  checked="true" ';
			echo 'value="'.$category->category_id.'"/> '._($category->category_name).'</dd>'."\n";
		}
		echo '</dl>'."\n";
	}
	echo '<br style="clear: both;"/>' . "\n";
	echo '</fieldset>';
}

function do_vertical_tags($what=false) {
	global $db, $globals, $dblang;

	if (!empty($what)) {
		$status = '= "'.$what. '"';
	} else {
		$status = "!= 'discarded'";
	}
	if(!empty($globals['meta_categories'])) {
		$meta_cond = 'and link_category in ('.$globals['meta_categories'].')';
	}

	if(memcache_mprint('tags_3_'.$status.$meta_cond)) return;

	$min_pts = 8;
	$max_pts = 20;
	$line_height = $max_pts * 0.70;

	$min_date = date("Y-m-d H:i:00", $globals['now'] - 172800); // 48 hours (edit! 2zero)
	$from_where = "FROM tags, links WHERE tag_lang='$dblang' and tag_date > '$min_date' and link_id = tag_link_id and link_status $status $meta_cond GROUP BY tag_words";
	$max = max($db->get_var("select count(*) as words $from_where order by words desc limit 1"), 3);
	$coef = ($max_pts - $min_pts)/($max-1);

	$res = $db->get_results("select tag_words, count(*) as count $from_where order by count desc limit 30");
	if ($res) {
		$output = '<div class="vertical-box">';
		$output .= '<h4><a href="'.$globals['base_url'].'cloud.php">'._('etiquetas').'</a></h4><p 
		class="nube">'."\n";
		foreach ($res as $item) {
			$words[$item->tag_words] = $item->count;
		}
		ksort($words);
		foreach ($words as $word => $count) {
			$size = round($min_pts + ($count-1)*$coef, 1);
			$output .= '<a style="font-size: '.$size.'pt" href="';
			if ($globals['base_search_url']) {
				$output .= $globals['base_url'].$globals['base_search_url'].'tag:';
			} else {
				$output .= $globals['base_url'].'search.php?p=tag&amp;q=';
			}
			$output .= urlencode($word).'">'.$word.'</a>  ';
		}
		$output .= '</p></div>';
		echo $output;
		memcache_madd('tags_3_'.$status.$meta_cond, $output, 600);
	}
}

function do_best_comments() {
	global $db, $globals, $dblang;
	require_once(mnminclude.'link.php');
	$foo_link = new Link();
	$output = '';

	if(memcache_mprint('best_comments_3')) return;

	$min_date = date("Y-m-d H:i:00", $globals['now'] - 22000); // about 6 hours 
	// The order is not exactly the comment_karma
	// but a time-decreasing function applied to the number of votes
	$res = $db->get_results("select comment_id, comment_order, user_login, link_id, link_uri, link_title, link_comments,  comment_karma*(1-(unix_timestamp(now())-unix_timestamp(comment_date))*0.5/22000) as value from comments, links, users  where comment_date > '$min_date' and comment_karma > 50 and comment_link_id = link_id and comment_user_id = user_id order by value desc limit 12");
	if ($res) {
		$output .= '<h4><a href="'.$globals['base_url'].'topcomments.php">'._('mejores comentarios').'</a></h4><ul class="topcommentsli">'."\n";
		foreach ($res as $comment) {
			$foo_link->uri = $comment->link_uri;
			$link = $foo_link->get_relative_permalink().get_comment_page_suffix($globals['comments_page_size'], $comment->comment_order, $comment->link_comments).'#comment-'.$comment->comment_order;
			$output .= '<li><strong>'.$comment->user_login.'</strong> '._('en').' <a onmouseout="tooltip.clear(event);"  onclick="tooltip.clear(this);" onmouseover="return tooltip.ajax_delayed(event, \'get_comment_tooltip.php\', \''.$comment->comment_id.'\', 10000);" href="'.$link.'">'.$comment->link_title.'</a></li>'."\n";
		}
		$output .= '</ul>';
		echo $output;
		memcache_madd('best_comments_3', $output, 300);
	}
}

function do_best_story_comments($link) {
	global $db, $globals, $dblang;

	$do_cache = false;
	$output = '';

	if ($link->comments > 30 && $globals['now'] - $link->date < 86400*4) $do_cache = true;

	if($do_cache && memcache_mprint('best_story_comments_'.$link->id)) return;

	$limit = min(25, intval($link->comments/5));
	$res = $db->get_results("select comment_id, comment_order, user_login, substring(comment_content, 1, 60) as content from comments, users  where comment_link_id = $link->id and comment_karma > 25 and comment_user_id = user_id order by comment_karma desc limit $limit");
	if ($res) {
		$output .= '<h4><a href="'.$link->get_relative_permalink().'/best-comments">'._('comentarios +valorados').'</a></h4><ul class="topcommentsli">'."\n";
		foreach ($res as $comment) {
			$url = $link->get_relative_permalink().get_comment_page_suffix($globals['comments_page_size'], $comment->comment_order, $link->comments).'#comment-'.$comment->comment_order;
			$output .= '<li><strong>'.$comment->user_login.':</strong> <a onmouseout="tooltip.clear(event);"  onclick="tooltip.clear(this);" onmouseover="return tooltip.ajax_delayed(event, \'get_comment_tooltip.php\', \''.$comment->comment_id.'\', 10000);" href="'.$url.'"><em>'.text_to_summary($comment->content, 50).'</em></a></li>'."\n";
		}
		$output .= '</ul>';
		echo $output;
		memcache_madd('best_story_comments_'.$link->id, $output, 300);
	}
}

function do_best_stories() {
	global $db, $globals, $dblang;

	if(memcache_mprint('best_stories_'.$globals['meta_current'])) return;

	require_once(mnminclude.'link.php');
	$foo_link = new Link();

	if ($globals['meta_current'] && $globals['meta_categories']) {
			$category_list = 'and link_category in ('.$globals['meta_categories'].')';
			$title = _('populares de').' <em>'.$globals['meta_current_name'].'</em>';
	} else {
		$category_list  = '';
		$title = _('populares');
	}
//	$output = '<div id="sidepop"><h4><a href="'.$globals['base_url'].'topstories.php">'.$title.'</a></h4>';
	$output = '<div id="sidepop">';

	$min_date = date("Y-m-d H:i:00", $globals['now'] - 129600); // 36 hours 
	// The order is not exactly the votes
	// but a time-decreasing function applied to the number of votes
//	$res = $db->get_results("select link_id, link_uri, link_title, link_votes+link_anonymous as votes, (link_votes+link_anonymous)*(1-(unix_timestamp(now())-unix_timestamp(link_date))*0.8/129600) as value from links where link_status='published' $category_list and link_date > '$min_date' order by value desc limit 10");
	$res = $db->get_results("select link_id, link_uri, link_title, link_votes+link_anonymous as votes, (link_votes+link_anonymous)*(1-(unix_timestamp(now())-unix_timestamp(link_date))*0.8/129600) as value from links where link_status='published' $category_list order by value desc limit 10");

	if ($res) {
		foreach ($res as $link) {
			$foo_link->uri = $link->link_uri;
			$url = $foo_link->get_relative_permalink();
			$output .= '<div class="mnm-pop">'.$link->votes.'</div>';
			$output .= '<h5><a href="'.$url.'">'.$link->link_title.'</a></h5>';
			$output .= '<div class="mini-pop"></div>'."\n";
		}
		$output .= '</div>'."\n";
		echo $output;
		memcache_madd('best_stories_'.$globals['meta_current'], $output, 300);
	}
}

function do_best_queued() {
	global $db, $globals, $dblang;
	require_once(mnminclude.'link.php');
	$foo_link = new Link();

	if(memcache_mprint('best_queued_'.$globals['meta_current'])) return;

	if ($globals['meta_current'] && $globals['meta_categories']) {
			$category_list = 'and link_category in ('.$globals['meta_categories'].')';
			$title = _('candidatas en').' <em>'.$globals['meta_current_name'].'</em>';
	} else {
		$category_list  = '';
		$title = _('candidatas');
	}

	$output = '<div id="sidepop"><h4><a href="'.$globals['base_url'].'promote.php">'.$title.'</a></h4>';

	$min_date = date("Y-m-d H:i:00", $globals['now'] - 86400*2); // 48 hours
	// The order is not exactly the votes
	// but a time-decreasing function applied to the number of votes
	$res = $db->get_results("select link_id, link_uri, link_title, link_votes+link_anonymous as votes, link_karma from links where link_status='queued' and link_date > '$min_date' $category_list order by link_karma desc limit 15");
	if ($res) {
		foreach ($res as $link) {
			$foo_link->uri = $link->link_uri;
			$url = $foo_link->get_relative_permalink();
			$output .= '<div class="mnm-pop queued">'.$link->votes.'</div>';
			$output .= '<h5><a href="'.$url.'">'.$link->link_title.'</a></h5>';
			$output .= '<div class="mini-pop"></div>'."\n";
		}
		$output .= '</div>'."\n";
		echo $output;
		memcache_madd('best_queued_'.$globals['meta_current'], $output, 300);
	}
}

function do_best_posts() {
	global $db, $globals, $dblang;
	$output = '';

	if(memcache_mprint('best_posts_3')) return;

	$min_date = date("Y-m-d H:i:00", $globals['now'] - 86400); // about 24 hours
	$res = $db->get_results("select post_id, post_content, user_login from posts, users where post_date > '$min_date' and  post_user_id = user_id and post_karma > 0 order by post_karma desc limit 10");
	if ($res) {
		$output .= '<h4><a href="'.post_get_base_url('_best').'">'._('mejores notas').'</a></h4><ul class="topcommentsli">'."\n";
		foreach ($res as $post) {
			$output .= '<li><strong>'.$post->user_login.'</strong>: <a onmouseout="tooltip.clear(event);"  onclick="tooltip.clear(this);" onmouseover="return tooltip.ajax_delayed(event, \'get_post_tooltip.php\', \''.$post->post_id.'\', 10000);" href="'.post_get_base_url($post->user_login).'/'.$post->post_id.'"><em>'.text_to_summary($post->post_content, 50).'</em></a></li>'."\n";
		}
		$output .= '</ul>';
		echo $output;
		memcache_madd('best_posts_3', $output, 300);
	}
}



function do_wp_questions($num=5) {

global $db_wp, $globals;

    $querystr = "
    SELECT wposts.*
    FROM wp_posts wposts
    WHERE wposts.post_status = 'publish'
    AND wposts.post_type = 'post'
    ORDER BY wposts.post_date DESC
    LIMIT ". $num;

    $output = '<div class="ad-answers">

     <h2> Últimas preguntas </h2>

    <dl>';

    $res= $db_wp->get_results($querystr);

    if ($res) {

        foreach ($res as $post) {

                            $output .= "<dt>";

                            $output .= '<a href="'.$post->guid.'" title="'.$post->post_title.'"> '.$post->post_title.'</a>';

                            $output .= "</dt>";
		}

     $output .= '</dl></div>';

                return $output;

    }

}




?>
